function InitPushService() {
	//上传push信息
	setTimeout(CreateOrUpdateUserPushInfo,1000);
	// 监听点击消息事件
	plus.push.addEventListener("click", function(msg) {
		plus.runtime.setBadgeNumber(0);
		clickPushMsg(msg);
	}, false);
	// 监听在线消息事件
	plus.push.addEventListener("receive", function(msg) {
		plus.runtime.setBadgeNumber(1);
		receiveMsg(msg);
	}, false);
}

function CreateOrUpdateUserPushInfo() {
	var info = plus.push.getClientInfo();
	mui.post(SettingAPI.CreateOrUpdateUserPushInfo, info,
		function(data) {});
}

function clickPushMsg(msg) {
	if (msg.aps) { // Apple APNS message
		//接收到在线APNS消息：
		//alert("点击在线APNS消息");
	} else {
		//接收到在线透传消息
		if(msg.payload){
			DispatchMsg(msg.payload,msg.title);
		}
		else if(msg.content){
			DispatchMsg(msg.content,msg.title);
		}
	}	
}

//处理推送消息
function receiveMsg(msg) {
	if (msg.aps) { // Apple APNS message
		//接收到在线APNS消息：
		plus.nativeUI.alert("有新消息了!");
	} else {
		//接收到在线透传消息
		if(msg.payload){
			DispatchMsg(msg.payload,msg.title);
		}
		else if(msg.content){
			DispatchMsg(msg.content,msg.title);
		}
	}	
}

function DispatchMsg(msgdata,title){
	if ( typeof(msgdata)=="string" ) {
		msgdata = JSON.parse(msgdata);
	}	
	console.log(msgdata.Action);
	switch(msgdata.Action) {
		case "conn-msg-newre":
			HadNewAddConnectionRequest();
		break;
		case "ChatNotiy":
			ChatNotiyHandle();
		break;		
		default:
			plus.nativeUI.alert("有新消息了!");
		break;
	}	
}

function pushMsg(msg) {
	clearAllPush();
}

/**
 * 清空所有推动消息
 */
function clearAllPush() {
	plus.push.clear();
}

function HadNewAddConnectionRequest(){
	ShowBubble("connectionbubble",true);
	var webview = plus.webview.getWebviewById('connection-index');
	webview.evalJS("ShowMsgBubble(true)");
}

function ChatNotiyHandle(){
	ShowBubble("connectionbubble",true);
	var webview = plus.webview.getWebviewById('connection-index');
	webview.evalJS("ShowMsgBubble(true)");
}

function OpenShopCart() {
	mui.openWindow({
		url: baseHost + "/Shop/cart",
		id: 'ShopCart',
		style: {
			top: '60px',
			bottom: '50px',
		},
		show: {
			aniShow: 'fade-in'
		}
	});
}

function ShowUserDetails(connid){
	mui.openWindow({
		id: 'UserDetails',
		url: '../connection/userdetail.html',
		extras :{
			ConnectionId:connid
		},
		show: {
			aniShow: 'fade-in',
			duration: 300
		},
		waiting: {
			autoShow: false
		}
	});	
}


//获取未读消息
function GetAllUnreadMessgae(MessageCriteria,callback){
	plus.nativeUI.showWaiting();
	try{
		AjaxTool(MessageAPI.QueryMessages,MessageCriteria,callback);
	}catch(e){
      plus.nativeUI.closeWaiting();
	}
}

function AjaxTool(url,params,callback,errorcallbak){
	mui.ajax(url, {
		data:params,
		async: true,
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 15000, //超时时间设置为10秒；
		success: function(data) {
			plus.nativeUI.closeWaiting();			
			data = JSON.parse(data);
			 if(callback){
			 	callback(data);
			}
		},
		error: function(xhr, type, errorThrown) {
			plus.nativeUI.closeWaiting();
			if(errorcallbak){
			 	errorcallbak();
			}			
			console.log("异步数据出错！")
		}
	});	
}

function ShowMsg(msg){
	if('iOS'==plus.os.name){
		mui.toast(msg);
	}
	else{
		plus.nativeUI.toast(msg);		
	}
}

String.prototype.PadLeft = function(totalWidth, paddingChar) {
	if (paddingChar != null) {
		return this.PadHelper(totalWidth, paddingChar, false);
	} else {
		return this.PadHelper(totalWidth, ' ', false);
	}
}
String.prototype.PadRight = function(totalWidth, paddingChar) {
	if (paddingChar != null) {
		return this.PadHelper(totalWidth, paddingChar, true);
	} else {
		return this.PadHelper(totalWidth, ' ', true);
	}

}
String.prototype.PadHelper = function(totalWidth, paddingChar, isRightPadded) {

	if (this.length < totalWidth) {
		var paddingString = new String();
		for (i = 1; i <= (totalWidth - this.length); i++) {
			paddingString += paddingChar;
		}

		if (isRightPadded) {
			return (this + paddingString);
		} else {
			return (paddingString + this);
		}
	} else {
		return this;
	}
}
String.prototype.trimall = function() {
return this.replace(" ", '').replace(" ", '');
}

// 格式化日期时间字符串，格式为"YYYY-MM-DD HH:MM:SS"
function dateToStr(d){
	return (d.getFullYear()+"-"+ultZeroize(d.getMonth()+1)+"-"+ultZeroize(d.getDate())+" "+ultZeroize(d.getHours())+":"+ultZeroize(d.getMinutes())+":"+ultZeroize(d.getSeconds()));
};

function ultZeroize(v,l){
	var z="";
	l=l||2;
	v=String(v);
	for(var i=0;i<l-v.length;i++){
		z+="0";
	}
	return z+v;
};