/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function($, owner) {
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if(loginInfo.account=='' || loginInfo.password==''){
			return callback('请填写登录信息');
		}
		if (!checkMobile(loginInfo.account)) {
			return callback('电话号码输入有误');
		}
		if (loginInfo.password.length < 6) {
			return callback('密码最短为 6 个字符');
		}
		//var users = JSON.parse(localStorage.getItem('$users') || '[]');
		loginService(loginInfo,callback);
	};

	function loginService(loginInfo,callback) {
		var mask = mui.createMask(function(){});
		var waiting = plus.nativeUI.showWaiting('登录中...', {padlock:true});
		mask.show();
		mui.ajax(ServerAPI.Login, {
			data: {
				UserName: loginInfo.account,
				Password: loginInfo.password,
				IsAutoLogin:true
			},
			async:false,
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
				data= JSON.parse(data);
				mask.close();
				waiting.close();
				if (data.IsSuccess) {
					owner.createState(data.Data, function() {});
				    callback();
				}
				else{
					if(data.StatuCode){
						if(data.StatuCode="103"){
							owner.createState(data.Data, function() {});
							callback();
						}
						else{
							callback(data.ExceptionInfo );
						}
					}
					else{
						callback(JSON.parse(data.Data)[0].msg);
					}
				}
			},
			error: function(xhr, type, errorThrown) {
				//异常处理；
				mask.close();
				waiting.close();
				result = type;
			}
		});
		return;
	}

	owner.createState = function(PartUserInfo, callback) {
		PartUserInfo.IsLogout = false;
		console.log(JSON.stringify(PartUserInfo))
		plus.storage.setItem("PartUserInfo", JSON.stringify(PartUserInfo));	
		return callback();
	};

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		if(regInfo.mobile.legth==""){
			return callback('请输入电话号码');
		}
		if (regInfo.password.length < 6) {
			return callback('密码最短需要 6 个字符');
		}
		if (regInfo.password != regInfo.passwordConfirm) {
			return callback('两次输入密码不一致');
		}
		if (!checkMobile(regInfo.mobile)) {
			return callback('电话号码输入有误');
		}
		var mask = mui.createMask(function() {});
		var waiting = plus.nativeUI.showWaiting('注册中...', {
		   padlock: true
		});
		mui.ajax(ServerAPI.register,{
			data: {
				account: regInfo.account,
				password: regInfo.password,
				confirmPwd: regInfo.passwordConfirm,
				mobile: regInfo.mobile
			},
			async: false,
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
				console.log(data)
				data = JSON.parse(data);
				mask.close();
				waiting.close();
				if (data && data.IsSuccess) {
					plus.nativeUI.toast('注册成功');
					callback();
				}
				else{
					plus.nativeUI.toast(data.ExceptionInfo);
				}
			},
			error: function(xhr, type, errorThrown) {
				mask.close();
				waiting.close();
				console.log(type);
			}
		});
	};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
	};

	var checkMobile = function(mobile) {
		if (!!mobile.match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/)&&mobile.length=="") {
				return true;
			}
		  return  true;
		};
	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
		if (!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};
}(mui, window.app = {}));