var imagebox;
(function(mui, window, document, undefined) {
	mui.init();
	var imgfilecount = 0;
	var imgServerName = new Array();
	var get = function(id) {
		return document.getElementById(id);
	};
	var qsa = function(sel) {
		return [].slice.call(document.querySelectorAll(sel));
	};
	var ui = {
		question: get('question'),
		tags: get('tags'),
		imageList: get('image-list'),
		submit: get('submit')
	};
	ui.clearForm = function() {
		ui.question.value = '';
		ui.tags.value = '';
		ui.imageList.innerHTML = '';
		imgfilecount = 0;
		imgServerName = new Array();
		ui.newPlaceholder();
	};
	ui.getFileInputArray = function() {
		return [].slice.call(ui.imageList.querySelectorAll('.image-item'));
	};
	ui.getFileInputIdArray = function() {
		var fileInputArray = ui.getFileInputArray();
		var idArray = [];
		fileInputArray.forEach(function(fileInput) {
			if (fileInput.attributes['file']) {
				idArray.push(fileInput.getAttribute('file'));
			}
		});
		return idArray;
	};
	ui.getImageFileFromLocal = function(holdid){
		var a = [{
			title: "拍照"
		}, {
			title: "从手机相册选择"
		}];
		plus.nativeUI.actionSheet({
			title: "选择图片",
			cancel: "取消",
			buttons: a
		}, function(b) {
			switch (b.index) {
				case 0:
					break;
				case 1:
					ui.getImage(holdid);
					break;
				case 2:
					ui.galleryImg(holdid);
					break;
				default:
					break
			}
		});			
	};
	ui.getImage = function(holdid){
		var c = plus.camera.getCamera();
		c.captureImage(function(e) {
			plus.io.resolveLocalFileSystemURL(e, function(entry) {
				imageUrl = entry.toLocalURL();
				ui.changeImage(holdid,imageUrl);
			}, function(e) {
				console.log("读取拍照文件错误：" + e.message);
			});
		}, function(s) {
			console.log("error" + JSON.stringify(s));
		}, {
			filename: "_doc/"
		});	
	};
	ui.galleryImg = function(holdid){
		plus.gallery.pick(function(a) {
			plus.io.resolveLocalFileSystemURL(a, function(entry) {
				plus.io.resolveLocalFileSystemURL("_doc/", function(root) {
					root.getFile(holdid.toString()+".jpg", {}, function(file) {
						console.log("文件存在："+file.name);
						file.remove(function() {
							entry.copyTo(root, holdid.toString()+".jpg", function(e) {
									ui.changeImage(holdid,e.fullPath+"?version=" + new Date().getTime());
								},
								function(e) {
									console.log('copy again image fail:' + e.message);
							});
						}, function() {
							console.log("delete image fail:" + e.message);
						});						
					}, function() {
						console.log("文件不存在：");
						//文件不存在
						entry.copyTo(root, holdid.toString()+".jpg", function(e) {
							ui.changeImage(holdid,e.fullPath);
						},
						function(e) {
							console.log('copy image fail:' + e.message);
						});
					});
				}, function(e) {
					console.log("get _www folder fail");
				});
			}, function(e) {
				console.log("读取文件错误：" + e.message);
			});
		}, function(a) {}, {
			filter: "image"
		});	
	};
	ui.changeImage = function(id,file){
		console.log(id)
		console.log(file)
		if (file) {
			var placeholder = document.getElementById(id);
			placeholder.style.backgroundImage = 'url(' + file + ')';
			placeholder.classList.remove('space');
			if (!placeholder.attributes['file']){
				ui.newPlaceholder();
			}
			placeholder.setAttribute('file', file);
		}		
	};
	var imageIndexIdNum = 0;
	ui.newPlaceholder = function() {
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');
		placeholder.setAttribute('id', 'holder-' + imageIndexIdNum);
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		closeButton.addEventListener('tap', function(event) {
			event.stopPropagation();
			event.cancelBubble = true;
			setTimeout(function() {
				ui.imageList.removeChild(placeholder);
			}, 0);
			return false;
		}, false);
		placeholder.addEventListener('tap', function(event) {
			ui.getImageFileFromLocal(this.attributes['id'].value);
		}, false);
		placeholder.appendChild(closeButton);
		ui.imageList.appendChild(placeholder);
	};
	ui.newPlaceholder();
	
	ui.compressImg = function(imgfile){
		lrz(imgfile, {quality : 0.8, 
	        before: function(){},
	        fail: function(){},
	        done: function (results){
	        	if(mui.os.ios){
	        		results.base64 = results.base64.substr("data:image/jpeg;base64,".length);
	        	}
	        	AjaxTool(FeedsAPI.UploadFeedImage,{
	        		content:results.base64
	        	},function(data){
	        		if(data.IsSuccess){
	        			imgServerName.push(data.Data);
	        			if(imgfilecount == imgServerName.length){
							var images='';
							for (i=0;i<imgServerName.length;i++) {
								if(images!=''){
									images =images+",";
								}
								images =images+imgServerName[i];
							}	        				
	        				ui.createnewfeed(images);
	        			}
	        		}
	        	});
	        }
	       }
	   	);		
	};
	
	ui.uploadImg = function(imgs){
		imgfilecount = imgs.length;
		for (i=0;i<imgs.length;i++) {
			ui.compressImg(imgs[i]);
		}		
	};
	ui.createnewfeed = function(images){
		AjaxTool(FeedsAPI.CreateFeed,{
			Content:ui.question.value,
			Tags:ui.tags.value,
			Images:images,
			FeedType:currentFeedType,
			PId:Pid,
			OrderId:OrderId,
			ProductImage:ProductImage,
			ProductName:ProductName
		},function(data){
			plus.nativeUI.closeWaiting();
			if(data.IsSuccess){
				ui.clearForm();	
				ShowMsg('发布成功!');
				console.log(dateToStr(new Date()))
				setTimeout(function(){
					plus.webview.getWebviewById('homeSubpage').evalJS("mui('#refreshContainer').pullRefresh().pulldownLoading();");
					plus.webview.currentWebview().close();
				},500);
			}else{
				ShowMsg('发布失败!');
			}
		},function(){
			plus.nativeUI.closeWaiting();
		});
	};
	
	ui.submit.addEventListener('tap', function(event) {
		if (ui.question.value == '') {
			return mui.toast('信息填写不符合规范');
		} 
		plus.nativeUI.showWaiting();
		var imgs = ui.getFileInputIdArray();
		if(imgs.length>0){
			ui.uploadImg(imgs);
		}else{
			ui.createnewfeed(null);
		}
	}, false);
	imagebox = ui;
})(mui, window, document, undefined);